# Python imports

# Lib imports
import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk

# Application imports



class WorkspaceFolderChoserButton(Gtk.FileChooserButton):
    def __init__(self):
        super(WorkspaceFolderChoserButton, self).__init__()

        self._setup_styling()
        self._setup_signals()
        self._subscribe_to_events()
        self._load_widgets()

        self.show_all()


    def _setup_styling(self):
        ctx = self.get_style_context()
        ctx.add_class("folder-choser-button")

        self.set_title("Chose Workspace")
        self.set_action( Gtk.FileChooserAction.SELECT_FOLDER )
        # self.set_uri("file:///home/abaddon/Coding/Projects/Active/Python_Projects/testing/lsp_manager")
        # self.set_uri("file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/LSP-Manager")
        self.set_uri("file:///home/abaddon/Coding/Projects/Active/Python_Projects/000_Usable/gtk/Newton_Editor")


    def _setup_signals(self):
        ...

    def _subscribe_to_events(self):
        event_system.subscribe("get-workspace-path", self.get_workspace_path)
        event_system.subscribe("get-workspace-uri", self.get_workspace_uri)

    def _load_widgets(self):
        ...

    def get_workspace_path(self):
        return self.get_file().get_path()

    def get_workspace_uri(self):
        return self.get_uri()